﻿# megaputer
Megaputer test project.

Тестовое задание С++ программиста
1. Необходимо написать на чистом С++ класс, умеющий максимально быстро читать
текстовые лог-файлы огромных размеров (около 20Mb в сутки, сотни суточных файлов) и
выдавать строки, удовлетворяющие условиям простейшего regexp: (как минимум
операторы * и ?, более широкий набор возможностей приветствуется).
Символ '*' - последовательность любых символов неограниченной длины. Символ "?" - один любой
символ.
Должны корректно отрабатываться маски: *Some*, *Some, Some*, *****Some*** -
не никаких ограничений на положение * в маске.
2. Класс не будет расширяться, и не будет базовым классом. Единственная задача:
сканирование и поиска в файлах. Класс должен иметь следующий публичный интерфейс
((все остальное должно быть скрыто):
class YourClassName
{
    public:
    YourClassName(..);
    ~YourClassName(..);
    Open(..);
    Close();
    SetFilter(..); // тут устанавливаем фильтр строк
    LPCSTR GetNextLine(int *linesize); // возвращаем очередную найденную строку 
    //  или NULL в качестве конца
}
3. Требование к реализации:
- Платформа: только Windows (NT 4.0 и выше).
- Функциональность: максимальная производительность, кэширование
результатов поиска и файла не требуется.
- Ресурсы: затраты памяти должны быть минимальны.
- Компоненты: запрещено использование сторонних библиотек (в том числе
STL) и компонентов. Разрешено использовать только WinAPI и CRT.
- Исключение: нельзя использовать Windows и С++ исключения (try, catch и
т.д.).
- Оформление:
1. Код должен быть максимально простым.
2. Код должен быть максимально чистым, красивым и понятным (допустим, что
класс выставляется на продажу за 1млн долларов).
3. Код должен быть абсолютно «неубиваемый» - защищённый о ошибок.
4. Результатом должен быть готовый класс (cpp + h файлы) и консольный пример
(открыть текстовый файл в пару мегабайт и сделать выборку "order*closed") его
использования. Файл и строка выбора должна указываться в аргументах примера.
5. Результатом должен быть образец работающего exе файла + проект для MSVS.
6. Дополнение: программа должна искать более сложные регулярные выражения,
например,
ab*abc
в строке
abababca
